PSP_ENVIRN_SEG  EQU     2CH
PSHIFT          EQU     1290H           ; = ofs(intr10) !!!
PLENGTH         EQU     19569
DID             EQU     0F7H
     
SEG_A           SEGMENT PARA PUBLIC
		ASSUME	CS:SEG_A, DS:SEG_A

                ORG     100H

LRSFD2          PROC    FAR
START:          JMP     MAIN
LRSFD2          ENDP

                DB      1078H DUP (?)   ; 4216 = 4096+64+316-256(PSP)-4
                ALIGN   16
MCB             DW      8 DUP(0)
PSP             DB      256 DUP(1)

                INCLUDE INTR10.INC
FONTBUF         DB      4096 DUP('F')
ACCESSID        DB      64 DUP(0)
   
MAIN:           CLD
                LEA     DX,MSG2
                MOV     AH,9
                INT     21H

                MOV     AH,30H          ; TEST DOS VERSION
                INT     21H
                XCHG    AL,AH
                CMP     AX,31EH         ; DOS >= 3.30
                JNC     LT_3
                LEA     DX,MSG5
                JC      LYY6

LT_3:           PUSH    DS              ; COPY PROGRAM NAME TO MSG
                MOV     DI,DS
                DEC     DI
                MOV     DS,DI
                LEA     DI,MSG4X
                MOV     SI,8
LT_2:           CMP     SI,10H
                JZ      LT_1
                MOVSB
                CMP     BYTE PTR [SI],0
                JNZ     LT_2
LT_1:           MOV     BYTE PTR ES:[DI],'$'
                POP     DS

                MOV     BX,80H          ; SET PRESENCE REMOVE FLAG (-R) IN
                MOV     CL,[BX]         ; COMMAND LINE
                OR      CL,CL
L3_4:           JZ      L3_1
                INC     BX
                MOV     AL,[BX]
                AND     AL,0DFH
                CMP     AL,'R'
                JZ      L3_3
                DEC     CL
                JMP     SHORT L3_4
L3_1:           MOV     AL,'M'
L3_3:           MOV     PARAM,AL

                CALL    REMOVE_PRESENCE
		MOV	ES,DS:PSP_ENVIRN_SEG

                XOR     BX,BX           ; COPY FULL PATH & NAME
LYY2:           CMP     WORD PTR ES:[BX],0
                JZ      LYY1
                INC     BX
                JNZ     LYY2
LYY1:           ADD     BX,4
                XOR     SI,SI
LYY4:           MOV     AL,ES:[BX]
                OR      AL,AL
                JZ      LYY3
                MOV     ACCESSID[SI],AL
                INC     SI
                INC     BX
                JNZ     LYY4

LYY3:           MOV     AH,49H          ; DOS Services  ah=function 49h
                INT     21H             ;  release memory block, es=seg

                LEA     DX,ACCESSID     ; OPEN
                MOV     AX,3D00H
                INT     21H
                MOV     BX,AX
                JNC     LYY5

LYY7:           LEA     DX,MSG10
LYY6:           MOV     AH,9
                INT     21H
                INT     20H

LYY5:           MOV     AX,4202H        ; CALCULATE FILESIZE
                XOR     CX,CX
                XOR     DX,DX
                INT     21H
                JC      LYY8

                PUSH    AX
                MOV     AH,3EH          ; CLOSE
                INT     21H
                POP     AX

                OR      DX,DX
                JNZ     LYY8

                CMP     AX,PLENGTH
                JZ      LYY9

LYY8:           LEA     DX,MSG9
                JMP     SHORT LYY6

LYY9:           LEA     DX,MSG4
                MOV     AH,9
                INT     21H
                LEA     DX,MSG4C
                MOV     AH,9
                INT     21H

                MOV     AH,34H          ; SET DOS CRITICAL FLAG ADDRESS
                INT     21H
                MOV     LO_DOS_F,BX
                MOV     HI_DOS_F,ES

                MOV     AX,3510H        ; DOS Services  ah=function 35h
                INT     21H             ;  get intrpt vector al in es:bx
                MOV     OVE10,BX
                MOV     OVE10+2,ES

                MOV     AH,4AH          ; SHRINK MEMORY ALLOCATED FOR THE PROG
                PUSH    CS
                POP     ES
                MOV     BX,(PSHIFT-110H)/10H
                INT     21H

                MOV     AH,26H          ; create new PSP
                MOV     DX,CS
                ADD     DX,(PSHIFT-100H)/10H
                INT     21H

                MOV     BX,DX           ; set current PSP
                MOV     AH,50H
                INT     21H

                MOV     MCB+1,DX
                
                CALL    MOVE2PSP

                XOR     DX,DX
                MOV     AX,2510H        ; DOS Services  ah=function 25h
                INT     21H             ;  set intrpt vector al to ds:dx

                CALL    SETFONT

                MOV     AX,4C00H
                INT     21H

REMOVE_PRESENCE PROC    NEAR
                MOV     AX,400H+DID
                MOV     DX,DID
                INT     10H
                MOV     ES,BX

                CMP     MSG2+50,'i'     ; SECURITY LINE
                JNZ     LYY8

                CMP     PARAM,'R'
                JZ      L10A

                CMP     DX,400H+DID
                LEA     DX,MSG1
                JZ      L46
                
                RETN

L10A:           CMP     DX,400H+DID
                LEA     DX,MSG7
                JNZ     L46

L10:            PUSH    ES              ; IS INTR 10 CATCHED?
                MOV     CX,ES
                MOV     AX,3510H
                INT     21H
                XOR     DX,DX
                CMP     DX,BX
                MOV     DX,ES
                POP     ES
                JNZ     L77
                CMP     DX,CX
L77:            JNZ     L45

                PUSH    DS

                MOV     DX,ES:OVE10-PSHIFT      ; restore int 10 vector
                MOV     DS,ES:OVE10-PSHIFT+2
                MOV     AX,2510H
                INT     21H

                MOV     BX,CS
                DEC     BX
                MOV     DS,BX
                MOV     BX,DS:1
                MOV     CX,ES
                DEC     CX
                MOV     DS,CX
                MOV     DS:1,BX

                MOV     AH,49H          ; FREE BLOCK
                INT     21H

                POP     DS

                CALL    SETFONT

                LEA     DX,MSG3
L46:            JMP     LYY6

L45:            LEA     DX,MSG8
                JNZ     L46

REMOVE_PRESENCE ENDP

SETFONT         PROC    NEAR
                XOR     BX,BX           ; LOAD ROM FONT
                MOV     ES,BX
                MOV     AX,1104H
                MOV     CL,24H
                MOV     CH,ES:485H
                CMP     CH,16
                JNC     LZZ1
                MOV     AL,1
                MOV     CL,22H
                CMP     CH,14
                JNC     LZZ1
                INC     AL
                INC     CL

LZZ1:           CMP     BL,ES:461H
                JNZ     LZZ2
                MOV     AL,CL
                MOV     DL,ES:484H
                INC     DL
LZZ2:           INT     10H
                RETN

SETFONT         ENDP

MOVE2PSP        PROC    NEAR
                LEA     SI,INTR10
                XOR     DI,DI
                MOV     CX,MAIN-INTR10
                REP     MOVSB           ; Rep when cx >0 Mov [si] to es:[di]
		RETN
MOVE2PSP        ENDP
                
MSG1            DB      'Driver is already loaded', 0AH, 0DH, '$'
MSG2            DB      'Little Removable Screen Font Driver 2 v1.00 '
                DB      'by V.Lidovski VI-1996',0DH,0AH,'$'
MSG3            DB      'Driver is removed',0AH,0DH,'$'
MSG4            DB      'Run '
MSG4x           DB      '123456789'
MSG4c           DB      ' -R to remove driver',0AH,0DH,'$'
MSG5            DB      'This program requires MS-DOS version 3.30 or higher'
                DB      0AH,0DH,'$'
MSG7            DB      'It''s impossible to remove driver or driver is not loaded'
                DB      0AH,0DH,'$'
MSG8            DB      'You may only remove program with uncatched interrupt 10'
                DB      0AH,0DH,'$'
MSG9            DB      'This program must not be modified (e.g. compressed by '
                DB      'PKLITE or LZEXE)',0AH,0DH,'$'
MSG10           DB      'Can''t find the main program file'
                DB      0AH,0DH,'$'
PARAM           DB      0
FONT16X8        LABEL   BYTE
                INCLUDE 8X16.INC
FONT14X8        LABEL   BYTE
                INCLUDE 8X14.INC
FONT8X8         LABEL   BYTE
                INCLUDE 8X8.INC
SEG_A           ENDS

		END	START
